<?php

class modJSRRelationArticlesHelper2
{
	function getRelationArticles( & $params )
	{
		$article_id = JRequest::getInt('article');

		if( !$article_id ) return '';

		JModel::addIncludePath( JPATH_ROOT.DS."components".DS.'com_resource'.DS.'models' );

		$m_list    = JModel::getInstance( 'list',    'ResModel' );
		$m_article = JModel::getInstance( 'article', 'ResModel' );

		$fields = $m_list->getFields( $article_id, 1 );
		
		if (!count($fields))
			return '';

		$article = $m_article->getArticle( $article_id );


		$out = '';
		$tab_close = false;
		
		$message = false;
		$emptyMessage = JText::_($params->get('empty_message', ''));
		
		$allowedTypes = $params->get('allowed_types', false);
		if ($allowedTypes) {
			$allowedTypes = explode(',', $allowedTypes);
			JArrayHelper::toInteger($allowedTypes);
			
			$relFields = array();
			for ($i = 0, $count = count($fields); $i < $count; $i++) {
				if( $fields[ $i ]->type == 'relate_child2') { 
					$p = new JParameter($fields[ $i ]->params);
					$fields[ $i ]->type_id = (int)$p->get('parent_type');
				}
				else if ($fields[ $i ]->type == 'relate_parent2') {
					$p = new JParameter($fields[ $i ]->params);
					$relFields [$fields[ $i ]->fid] = (int)$p->get('relate_field');
				}
			}
			
			if (count($relFields))
			{
				$db = & JFactory::getDBO();
				$db->setQuery('SELECT id, type_id FROM #__js_res_fields WHERE id IN ('.implode(', ', $relFields).')');
				$typeIds = $db->loadObjectList('id');
				
				
				if (is_array($typeIds)) {
					for ($i = 0, $count = count($fields); $i < $count; $i++) {
						if ($fields[ $i ]->type == 'relate_parent2') {
							$fields[ $i ]->type_id = @$typeIds[@$relFields[@$fields[ $i ]->fid]]->type_id;
						}
					}
				}
			}
		}
		
		$fFound = false;
		
		foreach( $fields as $field ) {
			if( !in_array( $field->type, array( 'relate_parent2', 'relate_child2' ) ) ){ 
				$message = JText::_('There is no Relate2 fields detected!');
				continue;
			}
				
			if ($allowedTypes && !in_array($field->type_id, $allowedTypes)){
				$message = JText::_('There is allowed Relate2 fields detected!');
				continue;
			}

			$fparam = new JParameter($field->params);

			$module_params = $params->toArray();

			foreach( $module_params as $key => $param ) {
				if ($key == 'show_type_label')
					continue;
				if( $param )
					$fparam->set( $key, $param );
				// Treat '0' values accordingly
				else if (is_numeric($param))
					$fparam->set( $key, $param );
			}
			
			// We won't have any "add new" or "add existing" buttons.
			$fparam->set('url_add_new', '');
			$fparam->set('add_existing', 0);

			$field->params = $fparam->toString();
						
			$output = modJSRRelationArticlesHelper2::renderField($field, $fparam, $article->user_id);
			if (!$output || JString::trim($output) == JText::_('No items')) {
				if ($emptyMessage) {
					if ($params->get('show_type_label', 1))
						$message = '<b>'.JString::ucfirst($field->title).': </b><div style="clear:both"></div>'.$emptyMessage;
					else
						$message = $emptyMessage;
				}
			}
			else {
				if( !$fparam->get( 'tabled' ) ) {
					if( !$tab_close ) {
						$out .= "</table>";
						$tab_close = true;
					} else {
						if( $tab_close ) $out .= '<table class="contentpaneopen" style="clear:both" width="100%">';
						$tab_close = false;
					}
				}
				
				$fFound = true;
				
				if ($params->get('show_type_label', 1))
					$out .= '<b>'.JString::ucfirst($field->title).': </b><div style="clear:both"></div>';
					
				$out .= $output.'<div style="clear:both"></div>';
			}
		}

		if (!$fFound && $message)
			$out .= $message.'<div style="clear:both"></div>';
		
			
		if ($fFound && !$tab_close) 
			$out .= "</table>";
		$text_before = $params->get('text_before', null);
		$text_after = $params->get('text_after', null);
		if ($text_before || $text_after) $out = '<div class="text_before">'.$text_before.'</div>'.$out.'<div class="text_after">'.$text_after.'</div>';
		return $out;
	}
	/**
	 * Renders given field with specified parameters. Note that the rendered field is autocreated. 
	 * @param $field The field
	 * @param $params JParameter
	 * @return string
	 */
	function renderField(&$field, &$params, $userId) {
        $get = '';
        
        $params->set('show_lable', 0);
        $params->set('tabled', 0);

        $dispatcher =& JDispatcher::getInstance();
        JPluginHelper::importPlugin('joomsuite_content_fields', $field->type);
        $dispatcher->trigger('onRenderFieldValue', array (&$get, & $field, & $params, $field->type, $userId));

        return $get;
	}
}

?>