<?php
defined('_JEXEC') or die('Access Denied');

class modLastCommentsHelper
{
	/*
		Gets last comments
	*/
	function getLastComments( $category_id, $params )
	{
		$db = JFactory::getDBO();
		
		$order = "com.ctime DESC";
		
		$sort_param = $params->get('sort', "com.ctime DESC");
		$sort = array(1 => "com.ctime DESC", 2 => "com.ctime ASC", 3 => "", 4 => "com.ctime ASC", 5 => "RAND()");

		foreach( $sort AS $key => $value ){
			if( $key == $sort_param ){
				$order = $value;
				break;
			}
		}
			
		if($order==''){
			$order = "com.ctime DESC";
		}
		
		$cat_where = "AND cat.id={$category_id}";
		if($params->get('show_nest_cat', 1)){
			$cat_where = modLastCommentsHelper::getChildCat($category_id);
		}
		$sql = 	"SELECT com.id AS comment_id, com.record_id, com.subject, com.comment, cat.name, com.name AS author_name, com.user_id, com.ctime, cat.id AS category_id, rec.id AS record_id,"
				." rec.title AS record_title"	
				."\nFROM #__js_res_comments AS com"
 				."\nLEFT JOIN #__js_res_record AS rec ON com.record_id = rec.id"
 				."\nLEFT JOIN #__js_res_record_category AS rec_cat ON rec_cat.record_id = rec.id"
				."\nLEFT JOIN #__js_res_category AS cat ON cat.id = rec_cat.catid" 				
				."\nWHERE com.published=1 AND com.access=0 AND com.hide=0 {$cat_where}"
  				."\nGROUP BY com.id"
 				."\nORDER BY {$order}";
 				
 		$sql .= ($params->get('limit', 5) != 0) ? "\nLIMIT 0, ".$params->get('limit',5) : "";
 				
		$result = $db->setQuery($sql);
		/*
		echo "<pre>";
		print_r($db->_sql);
		echo "</pre>";
		*/
		$return = $db->loadObjectList($result);
		return $return;
	}
	
	
	function getComments($category_id, $params)
	{
		$db = JFactory::getDBO();
		/*
			Get records id, from Category
		*/
		$sql = 	"SELECT record.id FROM #__js_res_record AS record "
				."\nLEFT JOIN #__js_res_record_category AS rec_cat ON record.id = rec_cat.record_id "
				."\nWHERE rec_cat.catid={$category_id}";
		
		$result = $db->setQuery($sql);
		/*
		echo "<pre>";
		print_r($db->_sql);
		echo "</pre>";
			*/
		$recordlist = $db->loadObjectList($result);
		if( count($recordlist) )
			return modLastCommentsHelper::getLastCommentsFromEveryRecord( $recordlist, $category_id, $params );				
		return ;
	}
	
	function getLastCommentsFromEveryRecord( $recordlist, $category_id, $params )
	{
		$db = JFactory::getDBO();
		
		$list = array();
		foreach($recordlist AS $record){
			$list[] = $record->id;
		}
				
		$sql = "SELECT MAX(com.id) AS id FROM #__js_res_comments com
				WHERE com.record_id IN (".implode(",", $list).")
				GROUP BY com.record_id;";
		
		$result = $db->setQuery($sql);
		
		$return = $db->loadObjectList();
		/*
		echo "<pre>";
		print_r($return);
		echo "</pre>";
		*/
		$list = array();
		foreach($return AS $ret){
			$list[] = $ret->id;
		}
		
		$order = "com.ctime DESC";
		
		$sort_param = $params->get('sort', "com.ctime DESC");
		$sort = array(1 => "com.ctime DESC", 2 => "com.ctime ASC", 3 => "", 4 => "com.ctime ASC", 5 => "RAND()");

		foreach( $sort AS $key => $value ){
			if( $key == $sort_param ){
				$order = $value;
				break;
			}
		}
		
		$sql = 	"SELECT com.id AS comment_id, com.record_id, com.subject, com.comment, cat.name, com.name AS author_name, com.user_id, com.ctime, cat.id AS category_id, rec.id AS record_id,"
				." rec.title AS record_title"	
				."\nFROM #__js_res_comments AS com"
 				."\nLEFT JOIN #__js_res_record AS rec ON com.record_id = rec.id"
 				."\nLEFT JOIN #__js_res_record_category AS rec_cat ON  rec_cat.record_id = rec.id"
				."\nLEFT JOIN #__js_res_category AS cat ON cat.id = rec_cat.catid" 				
				."\nWHERE com.published=1 AND com.access=0 AND com.hide=0 AND cat.id = {$category_id} AND com.id IN (".implode(",", $list).")"
  				."\nGROUP BY com.id"
 				."\nORDER BY {$order}";
 		$sql .= ($params->get('limit',0) != 0) ? "\nLIMIT 0, ".$params->get('limit',5) : "";
 		$result = $db->setQuery($sql);
 		/*echo "<pre>";
		print_r($db->_sql);
		echo "</pre>";*/
		return $db->loadObjectList();	
	}
	
	function getChildCat($category_id)
	{
		$children = array();
		// recursive get children categories
		modLastCommentsHelper::addChildren($category_id, $children);	
		if(count($children)) $sql = 'AND cat.id IN('.$category_id.','.implode(',', $children).')';		
		else $sql = 'AND cat.id='.$category_id;
		return $sql;
	}
	
	function addChildren($category_id, &$children)
	{
		$db =& JFactory::getDBO();
		
		$sql = "SELECT id FROM #__js_res_category WHERE parent=".intval($category_id);
		$db->setQuery($sql);
		$rows = $db->loadObjectList();
		
		foreach($rows AS $row){
			$found = false;
			
			foreach($children AS $idx){
				if($idx == $row->id){
					$found = true;
					break;
				}
			}
			if(!$found){
				$children[] = $row->id;
			}
			modLastCommentsHelper::addChildren($row->id, $children);
		}
	}
}
?>