<?php
defined('_JEXEC') or die('Restricted Access');

class modSecSummaryHelper
{
	function getSectionInfo($catid, $params)
	{
		
		$realCategory =  modSecSummaryHelper::getRealCategory($catid);
		
		$listModel = &JModel::getInstance('List', 'ResModel');
		$array = ResHelper::getCategoryChildrenIds($realCategory->id);
		$catArray = explode(",", $array);
		$catArray[] = $realCategory->id;
		$ret = array();
		//------------------------------------------------------------------------------
		$total_record_ids    = modSecSummaryHelper::getCountRecords($catArray, $params, 'total');
		$interval_record_ids = modSecSummaryHelper::getCountRecords($catArray, $params, 'interval');
		if ($params->get('records'))
		{
			$ret['total']['records']    = count($total_record_ids);
			$ret['interval']['records'] = count($interval_record_ids);
		}
		//------------------------------------------------------------------------------
		if ($params->get('hits'))
		{
			$ret['total']['hits']    =	modSecSummaryHelper::getHits($total_record_ids, $params, 'total');
			$ret['interval']['hits'] =	modSecSummaryHelper::getHits($total_record_ids, $params, 'interval');
		}
		//------------------------------------------------------------------------------
		if ($params->get('authors'))
		{
			$ret['total']['authors']    = modSecSummaryHelper::getAuthors($total_record_ids);
			$ret['interval']['authors'] = modSecSummaryHelper::getAuthors($interval_record_ids);
		}

		//------------------------------------------------------------------------------
		if ($params->get('comments'))
		{
			$ret['total']['comments']	  = modSecSummaryHelper::getCountComments($total_record_ids,  $params , 'total');
			$ret['interval']['comments'] = modSecSummaryHelper::getCountComments($total_record_ids, $params , 'interval');
		}

		//------------------------------------------------------------------------------
		if ($params->get('rating'))
		{
			$ret['total']['rating'] =  modSecSummaryHelper::getAverageRating($total_record_ids, $params, 'total');
			$ret['interval']['rating'] =  modSecSummaryHelper::getAverageRating($total_record_ids, $params, 'interval');
		}

		//------------------------------------------------------------------------------
		if ($params->get('favourites'))
		{
			$ret['total']['favourite'] =  modSecSummaryHelper::getCountFavourites($total_record_ids, $params, 'total');
			$ret['interval']['favourite'] =  modSecSummaryHelper::getCountFavourites($total_record_ids, $params, 'interval');
		}

		//------------------------------------------------------------------------------

		return $ret;

	}

	function getRealCategory($catid)
	{
		$db = &JFactory::getDBO();
		$sql = "SELECT `id`, `parent`, `name`, `description` FROM #__js_res_category WHERE `id` = ".(int)$catid;
		$db->setQuery($sql);
		$item = $db->loadObject();
		return $item;
	}

	function getCountRecords($categories, $params, $type = 'total')
	{
		$db = &JFactory::getDBO();
		$interval = '';
		if ($params->get('interval', 0) > 0 && $type == 'interval')
		{
			// This is a workaround for INTERVAL WEEK, that MySQL 4.x does not support
			$tmpInterval 		= $params->get('interval');
			$tmpIntervalType 	= $params->get('interval_type');
			if ($params->get('interval_type') == 'WEEK') {
				$tmpInterval 		= $params->get('interval') * 7;
				$tmpIntervalType	= 'DAY';
			}
			$interval = "AND r.mtime > (NOW() - INTERVAL ".$tmpInterval." ".$tmpIntervalType.")";
		}
		$sql = "SELECT rescat.record_id AS id FROM #__js_res_record_category AS rescat"
		."\n LEFT JOIN #__js_res_record AS r ON rescat.record_id = r.id"
		."\n WHERE 1 AND rescat.catid IN (".implode(" , ", $categories).") "
		.$interval;


		$db->setQuery($sql);
		return $db->loadResultArray();



	}

	function getAuthors($records = array())
	{
		if (count($records))
		{
			$db = &JFactory::getDBO();
			$sql = "SELECT `user_id` FROM #__js_res_record"
			." WHERE `id` IN (".@implode(" , ", $records).") GROUP BY `user_id`";

			$db->setQuery($sql);

			return count($db->loadResultArray());
		}
		return 0;

	}


	function getHits($records, $params, $type='total')
	{
		$db = &JFactory::getDBO();
		$interval = '';

		if ($params->get('interval', 0) > 0 && $type == 'interval')
		{
			// This is a workaround for INTERVAL WEEK, that MySQL 4.x does not support
			$tmpInterval 		= $params->get('interval');
			$tmpIntervalType 	= $params->get('interval_type');
			if ($params->get('interval_type') == 'WEEK') {
				$tmpInterval 		= $params->get('interval') * 7;
				$tmpIntervalType	= 'DAY';
			}
			$interval = "AND ctime > (NOW() - INTERVAL ".$tmpInterval." ".$tmpIntervalType.")";
		}

		$sql = "SELECT COUNT(*) FROM #__js_res_hits WHERE 1 AND record_id IN (".implode(' , ',$records).") ".$interval;
		$db->setQuery($sql);
		return $db->loadResult();
	}

	function getCountComments($records, $params, $type='total')
	{
		$db = &JFactory::getDBO();
		$interval = '';
		if ($params->get('interval', 0) > 0 && $type == 'interval')
		{
			// This is a workaround for INTERVAL WEEK, that MySQL 4.x does not support
			$tmpInterval 		= $params->get('interval');
			$tmpIntervalType 	= $params->get('interval_type');
			if ($params->get('interval_type') == 'WEEK') {
				$tmpInterval 		= $params->get('interval') * 7;
				$tmpIntervalType	= 'DAY';
			}
			$interval = "AND ctime > (NOW() - INTERVAL ".$tmpInterval." ".$tmpIntervalType.")";
		}

		$sql = "SELECT COUNT(*) FROM #__js_res_comments "
		." WHERE 1 AND `published` = 1 AND `record_id` IN (".implode(" , ", $records).") ".$interval;
		$db->setQuery($sql);
		return $db->loadResult();
	}

	function getAverageRating($records, $params, $type='total')
	{
		$db = &JFactory::getDBO();
		$interval = '';
		if ($params->get('interval', 0) > 0 && $type == 'interval')
		{
			// This is a workaround for INTERVAL WEEK, that MySQL 4.x does not support
			$tmpInterval 		= $params->get('interval');
			$tmpIntervalType 	= $params->get('interval_type');
			if ($params->get('interval_type') == 'WEEK') {
				$tmpInterval 		= $params->get('interval') * 7;
				$tmpIntervalType	= 'DAY';
			}
			$interval = "AND ctime > (NOW() - INTERVAL ".$tmpInterval." ".$tmpIntervalType.")";
		}

		$sql = "SELECT  CEIL(SUM(vote) / COUNT(*)) AS rating FROM ".
		"#__js_res_vote WHERE record_id  IN (".implode(" , ", $records).") ".$interval." GROUP BY record_id";

		$db->setQuery($sql);

		$results =  $db->loadResultArray();

		$total = 0;
		foreach ($results as $res)
		{
			$total+=$res;

		}
		if (count($results)>0){return (int)($total/count($results));}
		else {return 0;}

	}

	function getCountFavourites($records, $params, $type="total")
	{
		$db = &JFactory::getDBO();
		$interval='';
		if ($params->get('interval', 0) > 0 && $type == 'interval')
		{
			// This is a workaround for INTERVAL WEEK, that MySQL 4.x does not support
			$tmpInterval 		= $params->get('interval');
			$tmpIntervalType 	= $params->get('interval_type');
			if ($params->get('interval_type') == 'WEEK') {
				$tmpInterval 		= $params->get('interval') * 7;
				$tmpIntervalType	= 'DAY';
			}
			$interval = "AND ctime > (NOW() - INTERVAL ".$tmpInterval." ".$tmpIntervalType.")";
		}

		$sql = "SELECT COUNT(*) FROM #__js_res_favorite "
		."WHERE record_id IN  (".implode(" , ", $records).")".$interval;

		$db->setQuery($sql);

		return (int)$db->loadResult();

	}
}


?>