<?php

class mod_jsc_tag_relationHelper
{
	function getList( $id, $params )
	{
		JModel::addIncludePath(JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'models');
		$model = JModel::getInstance('Article', 'ResModel');
		$tags = $model->getTags($id);

		$tags = explode(',', $tags);
		if (count($tags)<1)
		{
			return array();
		}
		$rows = array();
		for ($i = 0 ; $i < count($tags); $i++)
		{
			$tags[$i] = ltrim($tags[$i]);
			$tags[$i] = rtrim($tags[$i]);
			$tags[$i] = "'".$tags[$i]."'";

		}
		$db = & JFactory::getDBO();
		$sql = mod_jsc_tag_relationHelper::buildQuery($params, $tags, $id);
		$db->setQuery($sql);
		$rows = $db->loadObjectList();
		/*
		echo "<pre>";
		print_r($db->_sql);
		echo "</pre>";
		*/
		return $rows;
	}
	function buildQuery($params, $tags, $id)
	{
		global $mainframe, $option;

		$where = mod_jsc_tag_relationHelper::buildWhere($params, $tags, $id);
		$order = mod_jsc_tag_relationHelper::buildOrder($params);
		$query = "SELECT r.* , r.id , c.catid as catid " .
			"\n FROM #__js_res_record AS r " .
			"\n LEFT JOIN #__js_res_record_category AS c ON c.record_id = r.id " .
			"\n LEFT JOIN #__js_res_category AS rc ON rc.id = c.catid " .
			"\n	LEFT JOIN #__js_res_tags_history as th ON th.record_id = r.id ".
			"\n	LEFT JOIN #__js_res_tags as t ON th.tag_id = t.id".
			$where .
			"\n GROUP BY r.id ";
	        if($order)
			{
				$query .= "\n ORDER BY ". $order;
			}
		$query .= ( $params->get('max_content_number', 0) ) ? "\n LIMIT 0, ".$params->get('max_content_number', 0) : "";			
//		echo $query;    
		return $query;
	}
	
    function buildOrder( $params )
	{
	    $order = array();
		if ($params->get('show_only_featured', 0) == 2 ){
			$order[] = "r.featured DESC";
		}
		
	    if($order)
		{
			return implode(',', $order);
		}
	}
	
	function buildWhere($params, $tags, $id)
	{
		$wl = array();
		$where = array();
		$now = ResHelper::getDate();

		if( strlen(trim($params->get('exclude_category_id_list'))) ){
			$exc_category_id_list = explode(",", trim($params->get('exclude_category_id_list')));
			$list = array();
			if( count($exc_category_id_list) ){
				foreach($exc_category_id_list AS $c){
					if( intval($c) ) $list[] = intval($c);
				}
				if( count($list) ){
					$where[] = "r.id NOT IN( ".implode(",", $list)." ) ";
				}
			}
		}
		
		if (count($tags)>0)
		{
			$where[] = 't.tag IN ('.implode(' , ', $tags).')';

		}
		
	    // normal time artilcles
		if($params->get('time_period', "default_time") == "default_time"){
			$where[] = "( (r.extime = '0000-00-00 00:00:00' OR r.extime > NOW()) AND r.ctime < NOW() )";
		} 
		// old expired articles
		else if( $params->get('time_period') == 'expired_time'){
			$where[] = "(r.extime < NOW() AND r.extime <> '0000-00-00 00:00:00')";
		}
		// future time articles
		else if( $params->get('time_period') == 'future_time'){
			$where[] = "(r.ctime > NOW())";
		}
		
    	if( $params->get('show_only_featured', 0) == 1 ){
			$where[] = "\n r.featured=1";
		}
		
		if(count($where)>0)
		{
			$where = " WHERE (".implode( ' AND ', $where ).") AND r.id != {$id}";
			return $where;
		}

	}


}
?>